#include <iostream>
#include "verem.h"

using namespace std;

int main()
{
    try
    {
        cout << "Helyes zarojelezes program" << endl;
        string X;
        cout << "Kerek egy zarojelekbol allo szoveget:\n";
        // Szöveg bekérés: ENTER-ig olvas
        cin >> X;
        Verem V;
        bool helyes=true;
        // indexváltozó ami végigmegy a szövegen
        int i=0;
        while(helyes && i<(int)X.size())
        {
            // String indexelés char-t ad vissza
            if(X[i]=='(')
            {
                V.verembe(i);
            }
            else if(X[i]==')')
            {
                // Ha nem üres, jó, ha üres, akkor bezártunk egy meg nem nyitottat
                if(!V.ures_e())
                {
                    int k=V.verembol();
                    // Találtunk egy zárójelpárt, kiírjuk
                    cout<<"("<<k+1<<","<<i+1<<") ";
                }
                else
                {
                    helyes=false;
                    cerr<<"\nVaratlan csuko zarojel.\n";
                }
            }
            else
            {
                // Egyéb, nem zárójel karakter
                cerr<<X[i]<<" karakter a szoveg "<<i+1<<". poziciojan!";
            }
            ++i;
        }
        if(!V.ures_e())
        {
            // Ha nem üres, maradt bezáratlan nyitó
            cout<<"\nTobb nyito, mint csuko zarojel.\n";
        }
        helyes=helyes && V.ures_e();
        if(helyes)
            cout<<"\nA zarojelezes helyes.\n";
        else
            cout<<"\nA zarojelezes nem helyes\n";
    }
    // Kivételek kezelése
    catch(Verem::Hiba h)
    {
        // Itt kezeljük a Verem osztályhoz definiált hibákat
        switch(h)
        {
        case Verem::UresVerem:
            cout << "Ures veremnek nincs teteje" << endl;
            break;
        case Verem::HibasMeret:
            cout << "Negatív méret a verem konstruktorban" << endl;
            break;
        default:
            cout << "Egyéb hiba tortent" << endl;
            break;
        }
    }
    catch(...)
    {
        // Itt pedig minden más hibát
        cout << "Fogalmam sincs, mi van" << endl;
    }
    return 0;
}
